#include <avr/io.h>

#include "utils.h"
#include "bitmanip.h"
#include "timer.h"

#define PERIOD						1000
#define PRESCALE_VALUE				1024		                    // can be 1, 8, 64, 256, 1024
#define DUTY_CYCLE					10

// turns on led2 at 1Hz and duty cycle of 10%, not using PORTx, with empty infinite loop
int main() {
	MODE_OUTPUT(LED2);

    SET(TCCR1A, WGM11);							                	// Table 16-4 : set timer in Fast PWM (Pulse With Modulation) mode with TOP = ICR1 (Mode 14)
	SET(TCCR1B, WGM12);
    SET(TCCR1B, WGM13);

	SET(TCCR1A, COM1A1);						                	// Table 16-2 : non-inverting mode, the LED will be ON for DUTY_CYCLE% of the time (CLEAR OC1A on compare match, SET OC1A at BOTTOM)

    ICR1 = TIME_MS(PERIOD, PRESCALE_VALUE);		                	// Table 16-4 : set the period (compare TOP value)
    
    OCR1A = TIME_MS(PERCENT(DUTY_CYCLE, PERIOD), PRESCALE_VALUE);	// 16.9.3 : set the duty cycle to DUTY_CYCLE% of the time on channel A -> OC1A (alternate function of PORTB1, aka LED2) is cleared when TCNT1 (the counter value) equals OCR1A

    TCCR1B |= (PRESCALE_SET(PRESCALE_VALUE));	                	// start the timer with the prescaler

	while(1);
}